﻿window.pmc = window.pmc || {};


window.pmc.formatString = function (inValue) {
    var newStr;
    if (typeof inValue == "undefined") {
        return "";
    } else if (typeof inValue == "string") {
        newStr = inValue.toLowerCase().trim();
    } else {
        newStr = inValue.toString().toLowerCase().trim();
    }
    newStr = newStr.replace(/"/g, "'");
    return newStr;
};

window.pmc.passScriptCheck = function (inText) {
    if (typeof inText != "undefined") {
        if (inText.match(/<script/i)) {
            window.pmc.debugLog("passScriptCheck failed");
            return false;
        }
    }
    return true;
};

window.pmc.setAttribute = function (inJQObj, inAttrName, inAttrValue) {
    if (typeof inJQObj == "undefined" || inJQObj.length === 0 || !inAttrName || inAttrValue === "") {
        return;
    }
    inJQObj.attr(inAttrName, inAttrValue);
};

window.pmc.getMetaTagContent = function (inMTName) {
    try {
        var myMTContent = jQuery("meta[name=\'" + inMTName + "\']");
        if (myMTContent.length > 0) {
            myMTContent = myMTContent[myMTContent.length - 1].content;
        } else {
            myMTContent = null;
        }
        return myMTContent;
    } catch (e) {
        return null;
    }
};

window.pmc.setMetaTagContent = function (inMTName, inMTContent) {
    if (!inMTContent) {
        return;
    } else if (window.pmc.getMetaTagContent(inMTName) === null) {
        var myMetaTag = document.createElement("meta");
        myMetaTag.name = inMTName;
        myMetaTag.content = inMTContent;
        if (window.pmc.passScriptCheck(myMetaTag.content)) {

            document.getElementsByTagName("head")[0].appendChild(myMetaTag);
        }
    } else {
        jQuery("meta[name=\'" + inMTName + "\']").attr("content", inMTContent);
    }
};


window.pmc.checkMetaTags = function (name, val) {
    //using javascript due to some sections having old versions of jquery
    var metaTag = document.querySelector('meta[name="' + name + '"]');
    if (!metaTag) {
        window.pmc.setMetaTagContent(name, val);
    }
};

window.pmc.webtrendsCheck = function (name, val, alt) {
    var reg = new RegExp(name, 'i');
    jQuery("meta").each(function () {
        var jqName = jQuery(this).attr("name");
        if (jqName) {
            if (jQuery(this).attr("name").match(reg)) {
                var wtContent = jQuery(this).attr("content");
                wtContent = wtContent.replace(/_/g, "");
                window.pmc.setMetaTagContent(val, wtContent); //assign wt content to wedecs variable
            } else {  //webtrends variable does not exist on the page
                if (alt) {
                    window.pmc.setMetaTagContent(val, alt);
                }
            }
        }
    });
};

window.pmc.webtrendsLangLocCheck = function (msLang, msLoc, lang, loc) {
    //this function is specific to windows/ pages pertaining to lang and loc
    //using javascript due to some sections having old versions of jquery
    var wtVar = document.querySelector('meta[name="DCSext.WClocale"]');
    if (wtVar) {  //webtrends variable exists
        var wtContent = wtVar.content;
        wtContent = wtContent.replace(/_/g, "");
        wtLang = wtContent.split("-")[0];
        wtLoc = wtContent.split("-")[1];
        window.pmc.setMetaTagContent(msLang, wtLang); //assign wt content to wedecs variable
        window.pmc.setMetaTagContent(msLoc, wtLoc); //assign wt content to wedecs variable
    } else {  //webtrends variable does not exist on the page
        window.pmc.setMetaTagContent(msLang, lang); //assign window.navigator.language[0] to wedecs variable
        window.pmc.setMetaTagContent(msLoc, loc); //assign window.navigator.language[1] to wedecs variable
    }
};


window.pmc.pageLoad = function () {
    window.pmc.libraryTaggingEnabled = false;
    var pageURL = window.location.hostname + window.location.pathname;

    //apply common non-site section specific values to only technet hosted pages
    if (window.location.hostname.match(/technet\.microsoft\.com/i) || window.location.hostname.match(/technet\.com/i) || window.location.hostname.match(/^technetappsmain\./i) || window.location.hostname.match(/^tngmain\./i)) {
        //Environment
        if (window.location.hostname.match(/^int\./) || window.location.hostname.match(/^technetappsmain\./i) || window.location.hostname.match(/^tngmain\./i)) { //staging hosts across technet
            window.pmc.checkMetaTags("ms.env", "staging");
        } else {
            window.pmc.checkMetaTags("ms.env", "production");
        }
        //language/location
        var lang, loc;
        var langLoc = window.location.pathname.match(/\/..-..\//);
        if (langLoc) {
            var grabbed_langLoc = langLoc[0];
            var grabbed_lang = grabbed_langLoc.split("-")[0];
            var grabbed_loc = grabbed_langLoc.split("-")[1];
            lang = grabbed_lang.replace("/", "");
            loc = grabbed_loc.replace("/", "");
            window.pmc.checkMetaTags("ms.lang", lang);
            window.pmc.checkMetaTags("ms.loc", loc);
        } else {
            //due to not having a consistent presence of lang/loc in the url, we user navigation.language
            var userLang = navigator.language || navigator.userLanguage;
            lang = userLang.split("-")[0];
            loc = userLang.split("-")[1];
            window.pmc.checkMetaTags("ms.lang", lang);
            window.pmc.checkMetaTags("ms.loc", loc);
        }
        //get html title element to eventually pass into ms.title
        window.pmc.pageTitle = window.pmc.formatString(jQuery(document).find("title").text());
        //truncate substring of the title
        window.pmc.pageTitle = window.pmc.pageTitle.substring(0, 100);

        if (pageURL.match(/technet\.microsoft\.com(\/..-..)?\/library/i)) {  //library (TECHNET LIBRARY ONLY)
            window.pmc.checkMetaTags("ms.sitesec", "library");
            window.pmc.msTitle = "library;" + window.pmc.pageTitle;
            window.pmc.libraryTaggingEnabled = true;
        } else if (pageURL.match(/social\.technet\.microsoft\.com\/wiki/i)) { //wiki
            window.pmc.checkMetaTags("ms.sitesec", "wiki");
            window.pmc.msTitle = "wiki;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com(\/..-..)?\/bb291022/i) || pageURL.match(/technet\.microsoft\.com(\/..-..)?\/dd644554/i) || pageURL.match(/technet\.microsoft\.com(\/..-..)?\/cc138021/i) || pageURL.match(/technet\.microsoft\.com(\/..-..)?\/ff871920/i)) { //Learn has all shortened links
            window.pmc.checkMetaTags("ms.sitesec", "learn");
            window.pmc.msTitle = "learn;" + window.pmc.pageTitle;
        } else if (pageURL.match(/gallery\.technet\.microsoft/i)) { //gallery
            window.pmc.checkMetaTags("ms.sitesec", "gallery");
            window.pmc.msTitle = "gallery;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com(\/..-..)?\/bb403698/i)) {  //downloads
            window.pmc.checkMetaTags("ms.sitesec", "downloads");
            window.pmc.msTitle = "downloads;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com(\/..-..)?\/ms772425/i)) {  //support
            window.pmc.checkMetaTags("ms.sitesec", "support");
            window.pmc.msTitle = "support;" + window.pmc.pageTitle;
        } else if (pageURL.match(/social\.technet\.microsoft.com\/forums/i)) {  //forums
            window.pmc.checkMetaTags("ms.sitesec", "forums");
            window.pmc.msTitle = "forums;" + window.pmc.pageTitle;
        } else if (pageURL.match(/blogs\.technet\.com/i)) { //blogs
            window.pmc.checkMetaTags("ms.sitesec", "blogs");
            window.pmc.msTitle = "blogs;" + window.pmc.pageTitle;
        } else if (pageURL.match(/social\.technet\.microsoft\.com\/search\//i)) {  //search
            window.pmc.checkMetaTags("ms.sitesec", "search");
            window.pmc.msTitle = "search;" + window.pmc.pageTitle;
            //apply search query on load using ms.searchquery
            var queryString = window.location.search;
            if (queryString.match(/query=/i)) {
                var titleToSearch = window.pmc.msTitle.split(" - microsoft technet search")[0];
                var removedSec = titleToSearch.split(";")[1];
                window.pmc.checkMetaTags("ms.searchquery", removedSec);
            }
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/windows/i)) {  //windows
            window.pmc.msTitle = "windows;" + window.pmc.pageTitle;
            //webtrends variable mapping process
            window.pmc.webtrendsCheck("DCSext.WCarea", "ms.sitesec", "windows");
            window.pmc.webtrendsLangLocCheck("ms.lang", "ms.loc", lang, loc);
            window.pmc.webtrendsCheck("DCSext.Wclifecycle", "ms.mkgtlfcycl");
            window.pmc.webtrendsCheck("DCSext.WCversion", "ms.prod");
            window.pmc.webtrendsCheck("DCSext.WCzone", "ms.pgtyp");
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/ie/i)) { //internet explorer
            window.pmc.checkMetaTags("ms.sitesec", "internet explorer");
            window.pmc.msTitle = "internet explorer;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/sqlserver/i)) {  //sql server
            window.pmc.checkMetaTags("ms.sitesec", "sql server");
            window.pmc.msTitle = "sql server;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/scriptcenter\//i)) {  //script center
            window.pmc.checkMetaTags("ms.sitesec", "script center");
            window.pmc.msTitle = "script center;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office/i)) { //office
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "office;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788774/i)) { //office 365
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "office 365;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788775/i)) { //exchange server
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "exchange server;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788776/i)) { //sharepoint products
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "sharepoint products;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788773/i)) { //lync
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "lync;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788954/i)) { //lync downloads and updates
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "lync;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788774/i)) { //office 365 for IT Pros
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "office 365 for it pros;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/fp160948/i)) { //office for IT pros
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "office for it pros;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788776/i)) { //sharepoint for IT pros
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "sharepoint for it pros;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788775/i)) { //exchange for IT pros
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "exchange for it pros;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788773/i)) { //Lync server for IT pros
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "lync server for it pros;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn788778/i)) { //Project server for IT pros
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "project server for it pros;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/..-..\/office\/dn770220/i)) { //support for Office products
            window.pmc.checkMetaTags("ms.sitesec", "office");
            window.pmc.msTitle = "support for office products;" + window.pmc.pageTitle;
        } else if (pageURL.match(/technet\.microsoft\.com\/((..-..)?\/?(((default)(\.aspx)?)?|(ms\d+(\.aspx)?)?))$/i) || pageURL.match(/technet\.microsoft\.com\/..-..\/.*$/i)) { //home page
            window.pmc.checkMetaTags("ms.sitesec", "home");
            window.pmc.msTitle = "home;" + window.pmc.pageTitle;
        }
        //universal checkMetaTags for ms.title
        window.pmc.checkMetaTags("ms.title", window.pmc.msTitle);
    }
};

window.pmc.setAttribute = function (inJQObj, inAttrName, inAttrValue) {
    if (typeof inJQObj == "undefined" || inJQObj.length === 0 || !inAttrName || inAttrValue === "") {
        return;
    }
    inJQObj.attr(inAttrName, inAttrValue);
};

window.pmc.wedcsUCTracking = [];
window.pmc.currUC = "";
window.pmc.setWEDCSAttributes = function (inJQObj, inCmpgrp, inCmpnm, inIndex) {
    var newUCTLen = window.pmc.wedcsUCTracking.push(window.pmc.currUC);
    window.pmc.setAttribute(inJQObj, "data-pmcucidx", (newUCTLen - 1));
    window.pmc.setAttribute(inJQObj, "ms.cmpgrp", inCmpgrp);
    window.pmc.setAttribute(inJQObj, "ms.cmpnm", inCmpnm);
    window.pmc.setAttribute(inJQObj, "ms.index", inIndex);

};

window.pmc.processWEDCSCustomEventFromArray = function (inArray) {
    if (typeof window.MscomCustomEvent != "function") {
        return;
    }

    if (typeof inArray == "undefined" || inArray === null || inArray.length === 0) {
        window.MscomCustomEvent();
        return;
    }

    window.MscomCustomEvent.apply(this, inArray);
};

window.pmc.processWEDCSCustomEventFromJQObj = function (inJQObj) {
    if (typeof inJQObj == "undefined" || inJQObj === null || inJQObj.length === 0) {
        window.pmc.processWEDCSCustomEventFromArray();
        return;
    }

    var myWEDCDAttrArray = [];

    jQuery(inJQObj[0].attributes).each(function () {
        if (this.nodeName && this.nodeName.indexOf("ms.") === 0) {
            myWEDCDAttrArray.push(this.nodeName, this.nodeValue);
        }
    });

    window.pmc.processWEDCSCustomEventFromArray(myWEDCDAttrArray);
};

window.pmc.cleanSearchQuery = function (searchVal) {
    var cleanedQuery;
    cleanedQuery = searchVal.replace(/(<([^>]+)>)/ig, "");
    cleanedQuery = searchVal.replace(/"/g, "'");
    cleanedQuery = searchVal.replace(/&/g, "+");
    return cleanedQuery;
};

window.pmc.tagForSearch = function () {
    //apply common non-site section specific search values to only technet hosted pages
    if (window.location.hostname.match(/technet\.microsoft\.com/i) || window.location.hostname.match(/technet\.com/i) || window.location.hostname.match(/^technetappsmain\./i) || window.location.hostname.match(/^tngmain\./i)) {
        //Tag search boxes across all of technet
        var cleanedQuery;
        //bing search at top of page
        window.pmc.currUC = "Bing Searchbox; top of page";
        jQuery("button#HeaderSearchButton").mousedown(function () {
            try {
                var searchVal = window.pmc.formatString(jQuery("#HeaderSearchTextBox").val());
                cleanedQuery = window.pmc.cleanSearchQuery(searchVal);
                window.pmc.setAttribute(jQuery(this), "ms.searchquery", cleanedQuery);
                window.pmc.processWEDCSCustomEventFromJQObj(jQuery(this));
            } catch (e) { }
        });

        jQuery("input#HeaderSearchButton").mousedown(function () {
            try {
                var searchVal = window.pmc.formatString(jQuery("#HeaderSearchTextBox").val());
                cleanedQuery = window.pmc.cleanSearchQuery(searchVal);
                window.pmc.setAttribute(jQuery(this), "ms.searchquery", cleanedQuery);
            } catch (e) { }
        });

        //case for wiki
        window.pmc.currUC = "Bing Searchbox; top of page on wiki sections";
        jQuery("#Header_SearchButton").mousedown(function () {
            try {
                var searchVal = window.pmc.formatString(jQuery("#Header_SearchTextBox").val());
                cleanedQuery = window.pmc.cleanSearchQuery(searchVal);
                window.pmc.setAttribute(jQuery(this), "ms.searchquery", cleanedQuery);
            } catch (e) { }
        });

        //case for wiki
        jQuery("input#Header_SearchTextBox").keydown(function (event) {
            if (event.which == 13) {
                try {
                    var searchVal = window.pmc.formatString(jQuery("#Header_SearchTextBox").val());
                    cleanedQuery = window.pmc.cleanSearchQuery(searchVal);
                    window.pmc.setAttribute(jQuery(this), "ms.searchquery", cleanedQuery);
                    window.pmc.processWEDCSCustomEventFromJQObj(jQuery(this));
                } catch (e) { }
            }
        });

        window.pmc.currUC = "Bing small Searchbox; top center of page";
        jQuery("#SearchButton").mousedown(function () {
            try {
                var searchVal = window.pmc.formatString(jQuery("#SearchTextBox").val());
                cleanedQuery = window.pmc.cleanSearchQuery(searchVal);
                window.pmc.setAttribute(jQuery(this), "ms.searchquery", cleanedQuery);
            } catch (e) { }
        });

        //When user presses the enter key to submit search query
        jQuery("#HeaderSearchTextBox").keydown(function (event) {
            if (event.which == 13) {
                try {
                    var searchVal = window.pmc.formatString(jQuery("#HeaderSearchTextBox").val());
                    cleanedQuery = window.pmc.cleanSearchQuery(searchVal);
                    window.pmc.setAttribute(jQuery(this), "ms.searchquery", cleanedQuery);
                    window.pmc.processWEDCSCustomEventFromJQObj(jQuery(this));
                } catch (e) { }
            }
        });

        //case for blogs
        jQuery("#HeaderSearchTextBox").off("mousedown").on("mousedown", function () {
            jQuery("#SuggestionContainer ul").off("mousedown").on("mousedown", function () {
                try {
                    var term = window.pmc.formatString(jQuery("input[title*='Search']").val());
                    window.pmc.setAttribute(jQuery(this), "ms.searchquery", term);
                    window.pmc.processWEDCSCustomEventFromJQObj(jQuery(this));
                } catch (e) { }
            });
        });

        //search box in search section

        jQuery("#SuggestionContainer ul").off("mousedown").on("mousedown", function () {
            try {
                var term = window.pmc.formatString(jQuery("input[title*='Search']").val());
                window.pmc.setAttribute(jQuery(this), "ms.searchquery", term);
                if (window.location.pathname.match(/\/search\//i)) {
                    window.pmc.setMetaTagContent("ms.searchquery", term);
                    window.pmc.processWEDCSCustomEventFromJQObj(jQuery(this));
                } else {
                    window.pmc.processWEDCSCustomEventFromJQObj(jQuery(this));
                }
            } catch (e) { }
        });

        //searchbox and button on search page
        jQuery("#SearchTextBox").on("input", function () {
            try {
                var searchText = jQuery(this).val();
                jQuery(this).attr("ms.searchquery", searchText);
                jQuery("a#SearchSubmitImage").attr("ms.searchquery", searchText);
            } catch (e) { }
        });

        jQuery("#SearchSubmitImage").on("mousedown", function () {
            try {
                var searchVal = window.pmc.formatString(jQuery("#SearchTextBox").val());
                cleanedQuery = window.pmc.cleanSearchQuery(searchVal);
                window.pmc.setAttribute(jQuery(this), "ms.searchquery", cleanedQuery);
                if (window.location.pathname.match(/\/search\//i)) {
                    window.pmc.setMetaTagContent("ms.searchquery", cleanedQuery);
                }
            } catch (e) { }
        });

        jQuery("input.search-button[title*='Search TechNet with Bing']").mousedown(function () {
            try {
                var searchVal = window.pmc.formatString(jQuery("input[name*='SearchTextBox']").val());
                cleanedQuery = window.pmc.cleanSearchQuery(searchVal);
                window.pmc.setAttribute(jQuery(this), "ms.searchquery", cleanedQuery);
                if (window.location.pathname.match(/\/search\//i)) {
                    window.pmc.setMetaTagContent("ms.searchquery", cleanedQuery);
                }
            } catch (e) { }
        });

        //on enter in search box
        jQuery("input[name*='SearchTextBox']").on("keydown", function (event) {
            try {
                //13 equals enter key on keyboard
                if (event.which == 13) {
                    var searchVal = window.pmc.formatString(jQuery(this).val());
                    cleanedQuery = window.pmc.cleanSearchQuery(searchVal);
                    window.pmc.setAttribute(jQuery(this), "ms.searchquery", cleanedQuery);
                    if (window.location.pathname.match(/\/search\//i)) {
                        window.pmc.setMetaTagContent("ms.searchquery", cleanedQuery);
                        window.pmc.processWEDCSCustomEventFromJQObj(jQuery(this));
                    } else {
                        window.pmc.processWEDCSCustomEventFromJQObj(jQuery(this));
                    }
                }
            } catch (e) { }
        });
    }
};

window.pmc.tagLeftNav = function () {
    //apply library section specific custom values to only technet hosted pages
    if (window.location.hostname.match(/technet\.microsoft\.com/i) || window.location.hostname.match(/technet\.com/i) || window.location.hostname.match(/^technetappsmain\./i) || window.location.hostname.match(/^tngmain\./i)) {
        var tCmpGrp = "";
        var tCmpNm = "";
        //left nav panel
        window.pmc.navIndex = "0";
        var currentLevel, prevLevel, prevCmpNmLevel, splitCmpNmLevel;
        window.pmc.currUC = "Left nav dropdown items";
        jQuery('#leftNav div[data-toclevel] a:not([class*="toc_"]):not([data-pmcucidx])').each(function () {
            var parentDropText = window.pmc.formatString(jQuery(this).closest('div[data-toclevel]').prevAll('.toclevel1:first').find("a:not([href='#'])").text());
            var levelNum = parseInt(jQuery(this).closest('div[data-toclevel]').attr("data-toclevel"), 10);
            //special cases for parent dropdowns
            if (levelNum === 0 || levelNum === 1) {
                parentDropText = window.pmc.formatString(jQuery(this).text());
            } else if (levelNum === -1) {
                levelNum = 0;
                parentDropText = window.pmc.formatString(jQuery(this).text());
            }
            tCmpNm = parentDropText + ';' + levelNum;

            currentLevel = jQuery(this).closest("div").attr("data-toclevel");
            prevLevel = jQuery(this).closest("div").prev().attr("data-toclevel");

            window.pmc.setWEDCSAttributes(jQuery(this), "table of contents", tCmpNm);

            try {
                if (currentLevel !== prevLevel) {
                    //new dropdown list item
                    window.pmc.navIndex = "0";
                    window.pmc.setAttribute(jQuery(this), "ms.index", window.pmc.navIndex);
                } else {
                    window.pmc.navIndex++;
                    window.pmc.setAttribute(jQuery(this), "ms.index", window.pmc.navIndex);
                }
            } catch (e) { }
        });
    }
};

window.pmc.tagElements = function () {
    //Temporary variables
    var tCmpGrp = "";
    var tCmpNm = "";
    var sideNavCounter = 0;
    var cmpnmCheck = "";

    window.pmc.tagLeftNav();

    //In this library; library home page
    window.pmc.currUC = "body directory links";
    jQuery("#content .navpage ul li a").each(function (index) {
        tCmpNm = jQuery(this).closest("ul").prev().text();
        if (tCmpNm === "\xA0") {
            tCmpNm = jQuery(this).closest("ul").prev().parent().prev().children(":header").text();
        }
        tCmpNm = window.pmc.formatString(tCmpNm);
        tCmpGrp = window.pmc.formatString(jQuery(this).closest(".navpage").find(":header:first").text());
        window.pmc.setWEDCSAttributes(jQuery(this), tCmpGrp, tCmpNm, index);
    });

    //See also links
    window.pmc.currUC = "alternative see also directory links";
    jQuery(".navpage div[style*='float'] a:not([data-pmcucidx])").each(function (index) {  //careful! style may change over time
        tCmpNm = window.pmc.formatString(jQuery(this).closest("ul").prev().text());
        if (tCmpNm === "") {
            tCmpNm = window.pmc.formatString(jQuery(this).closest(".navpage").find("div[style*='clear:both']:first").next().text());
            tCmpNm = tCmpNm.replace(":", "");
        }
        tCmpGrp = window.pmc.formatString(jQuery(this).closest(".navpage").find(":header:first").text());
        window.pmc.setWEDCSAttributes(jQuery(this), tCmpGrp, tCmpNm, index);
    });

    window.pmc.verbatim = "";
    //update the verbatim variable to ensure transfer of data when the submit button is clicked
    jQuery(".feedbackContainer textarea").on("input", function () {
        try {
            window.pmc.verbatim = jQuery(this).val().substring(0, 500).replace(/(<([^>]+)>)/ig, "").replace(/"/g, "'").replace(/&/g, "+");
        } catch (e) { }
    });

    //Submit button in feedback section
    jQuery(".feedbackContainer #feedbackSubmit").on("mousedown", function () {
        try {
            var jqFsButton = jQuery(this);
            //survey
            window.pmc.setAttribute(jqFsButton, "ms.srv_id", "was this page helpful?");
            //survey 
            window.pmc.setAttribute(jqFsButton, "ms.scnum", "feedbackform");
            //set cmpgrp, cmpnm, index
            tCmpNm = window.pmc.formatString(jQuery("#feedbackSection1").children(".left:first").text());
            window.pmc.setWEDCSAttributes(jqFsButton, "user feedback", tCmpNm, "0");

            //radio button feedback
            window.pmc.radioChoice = (jQuery(".feedbackContainer input[type=radio]:checked").attr("id") === "feedbackYes" ? "yes" : "no");

            //get checkbox feedback
            window.pmc.checkText = "";
            var tCBid = "";
            jQuery('.feedbackContainer input[name*="chkbxNo"]:checked').each(function () {
                tCBid = jQuery(this).attr("id");
                if (tCBid === "checkboxNo201") {
                    window.pmc.checkText += "not accurate|";
                } else if (tCBid === "checkboxNo202") {
                    window.pmc.checkText += "not enough depth|";
                } else if (tCBid === "checkboxNo203") {
                    window.pmc.checkText += "need more code examples|";
                } else if (tCBid === "checkboxNo204") {
                    window.pmc.checkText += "the translation needs improvement|";
                }
            });

            //Set ms.srv_resp to combination of radio and checkbox user choices
            var srv_resp = window.pmc.radioChoice;
            if (window.pmc.checkText.length > 0 && window.pmc.radioChoice === "no") {
                //checkbox value(s) were chosen
                //take off trailing pipe character from window.pmc.checkText
                srv_resp += ";" + window.pmc.checkText.substring(0, window.pmc.checkText.length - 1);
            }

            window.pmc.setAttribute(jqFsButton, "ms.srv_resp", srv_resp);

            if (window.pmc.verbatim === "") {
                window.pmc.verbatim = "no comment";
            }
            window.pmc.setAttribute(jqFsButton, "ms.srv_v", window.pmc.verbatim);
            window.pmc.processWEDCSCustomEventFromJQObj(jqFsButton);
        } catch (e) { }
    });
};

window.pmc.callMSJS = function () {

    window.pmc.pageLoad();

    //WEDCS base settings
    window.varClickTracking = 1;
    window.varCustomerTracking = 0;
    window.varAutoFirePV = 1;
    window.route = "";
    window.ctrl = "";

    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = window.location.protocol + "//c.microsoft.com/ms.js";
    document.getElementsByTagName("head")[0].appendChild(script);

    //tag search textboxes and buttons
    window.pmc.tagForSearch();

    //tag for click events
    if (window.pmc.libraryTaggingEnabled) {
        window.pmc.tagElements();
    }

    //AJAX Listener
    jQuery(document).ajaxComplete(function () {
        if (window.pmc.libraryTaggingEnabled) {
            window.pmc.tagLeftNav();
        }
    });
};

jQuery(document).ready(function () {
    window.pmc.callMSJS();
});